%**************************************************************************
% CLUSTER project: Store jav and divB              Autor: Christian Maszl * 
% Unit System = [SI]                  Mail: e0025754@student.tuwien.ac.at *
%**************************************************************************
%
% This subroutine store the computed data to the harddisk. 
% Filename format for jav: 
% [yymmdd]0000[type].jav.[t1]-[t2].[coordsys].[timeformat].[igmmat]
% Example: 0203040000fn.jav.0700-1019.gse.hr.igmmat
% 
% Format of the data in the file: [time jav]
%
% Filename format for <divB>: 
% [yymmdd]0000[type].divB.[t1]-[t2].[coordsys].[timeformat].[igmmat]
% Example: 0203040000fn.divB.0700-1019.gse.hr.igmmat

% Check for "outputdata" directory
if (isdir('../outputdata')==1)
else
    % Create "inputdata" directory
     mkdir('../outputdata');
     disp('Directory "outputdata" created. Proceed in execution!')
end
% Take a name of the datapackage and replace the satellite number with
% jav (current density)
satz = strrep(myfilelist{lauf,1},'.01.','.jav.');
satz = strrep(satz,'.igmasc','.igmmat');
     filename=['../outputdata/',satz];
% Create temporary carrier for output data and add time
     jav=[T jav];
% Save data (binary=5x faster) to disk
     save(filename,'jav','-mat'); 
% Take a name of the datapackage and replace the satellite number with
% divB
filename=['../outputdata/',strrep(satz,'.jav.','.divB.')];
% Create temporary carrier for output data and add time
     divB=[T divB];
% Save data (binary=5x faster) to disk
     save(filename,'divB','-mat'); 
% Clear dispensable variables
     clear filename satz;
