function plotdiagram(BA,BB,BC,BD,jav,divB)
%**************************************************************************
% CLUSTER project: Plot divB & curlB to screen     Autor: Christian Maszl *
% Unit System = [SI]                  Mail: e0025754@student.tuwien.ac.at *
%**************************************************************************

%[] Load data from a mat-file
%[] Find plot ranges

% Plot the x component of the current density versus the time.
subplot(4,2,1)
plot(jav(:,1),jav(:,2))
    axis([8.5 10.0 -3E-7 3E-7])
    ylabel('[jx]=A/m2','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    title('curl(B) & div(B)')
    grid on
% Plot the y component of the current density versus the time.
subplot(4,2,3)
plot(jav(:,1),jav(:,3))
    axis([8.5 10.0 -3E-7 3E-7])
    ylabel('[jy]=A/m2','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    grid on
% Plot the z component of the current density versus the time.
subplot(4,2,5)
plot(jav(:,1),jav(:,4))
    axis([8.5 10.0 -3E-7 3E-7])
    ylabel('[jz]=A/m2','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    grid on
% Plot <divB>/abs(curlB) versus the time.
divBocurlB=(divB(:,2)./sqrt(dot(jav(:,2:4),jav(:,2:4),2)))*100;
subplot(4,2,7)
plot(jav(:,1),divBocurlB)
    axis([8.5 10.0 0 0.005])
    ylabel('<divB>' ,'FontSize',12)
    xlabel('[t] = h','FontSize',12)
    grid on
% Calculate average of the B fiels
BX=(BA+BB+BC+BD)/4;
% Plot the x component of B versus the time
subplot(4,2,2)
plot(jav(:,1),BX(:,1))
    axis([8.5 10.0 -100 100])
    ylabel('[Bx] = nT','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    title('Average of the four B vectors')
    grid on
% Plot the y component of B versus the time.
subplot(4,2,4)
plot(jav(:,1),BX(:,2))
    axis([8.5 10.0 -100 100])
    ylabel('[By] = nT','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    grid on
% Plot the z component of B versus the time.
subplot(4,2,6)
plot(jav(:,1),BX(:,3))
    axis([8.5 10.0 -100 100])
    ylabel('[Bz] = nT','FontSize',12)
    xlabel('[t] = h'  ,'FontSize',12)
    grid on
% Calculate |B|
%B=sqrt(BX(:,1).*BX(:,1)+BX(:,2).*BX(:,2)+BX(:,3).*BX(:,3));
B=sqrt(dot(BX,BX,2));
% Plot |B| versus the time.
subplot(4,2,8)
plot(jav(:,1),B)
    axis([8.5 10.0 0 150])
    ylabel('|B| = nT' ,'FontSize',12)
    xlabel('[t] = h','FontSize',12)
    grid on
